 #include <X11/Xlib.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 
 #define RIGHT 0
 #define UP 1
 #define LEFT 2
 #define DOWN 3
 
 #define END 20000
 #define END_2 END >> 1
 
unsigned int x, y, count;
unsigned char arr[END+1];
Display *d;
Window w;
char direction; 
unsigned int s;
XEvent e;
unsigned int rot, strot;  //отвечает та разворот спирали


int spiralstep ()
{
switch (direction)
    {
        case RIGHT:
            y++;
            if (++rot == strot)
            {
                direction++;
                rot = 0;
            }
            break;
        case UP:
            x--;
            if (++rot == strot)
            {
                strot++;
                direction++;
                rot = 0;
            }
            break;
        case LEFT:
            y--;
            if (++rot == strot)
            {
                direction++;
                rot = 0;
            }     
            break;
        default:
            x++;
            if (++rot == strot)
            {
                strot++;
                direction=0;
                rot = 0;
            }
    }
return 0;
}


 
 int main(void) 
{
    arr[1]=0;
    arr[2]=1;
    arr[3]=1;
    count = 4;
    /*Заполняем единицами нечетные, двойками четные > 2. Первые четыре элемента массива не используются
    Как можно сделать, чтобы нумерация массива начиналась не с нуля?*/
    do
    {
        arr[count++] = 2;
        arr[count++] = 1;
    }
    while (count <= END);
    x = 3;
    while (x <= END_2)
    {
        count = 2;
        y = x << 1;
            while ((y = (x * count)) <= END)
            {
                count = count + 1;
                arr[y]++;
            }
        for (x = x + 2; arr[x] != 1; x = x + 2)
            ;
    }
    count = 1;
    while (count <= END)
    {
	   if (arr[count] == 1)
	       printf("%d, ", count);
       count++;
    }
    
    
    
//------------------------------------------------------------    

 
                        /* open connection with the server */
   d = XOpenDisplay(NULL);
   if (d == NULL) {
     fprintf(stderr, "Cannot open display\n");
     exit(1);
   }
 
   s = DefaultScreen(d);
 
                        /* create window */
   w = XCreateSimpleWindow(d, RootWindow(d, s), 10, 10, 400, 400, 1,
                           BlackPixel(d, s), WhitePixel(d, s));
 
                        /* select kind of events we are interested in */
   XSelectInput(d, w, ExposureMask | KeyPressMask);
 
                        /* map (show) the window */
   XMapWindow(d, w);
 
                        /* event loop */

    while (1)
    {
        XNextEvent(d, &e);
        if (e.type == Expose)
        {
             count = 1;
             rot = 0;
             strot = 1;
             direction = RIGHT;
             y = 200;
             x = 200;
                                                //RRGGBB                              
             XSetForeground(d, DefaultGC(d, s), 0xFF0000);
             XDrawPoint(d, w, DefaultGC(d, s), 200, 200);//красная точка в центре
             XSetForeground(d, DefaultGC(d, s), 0x000000);
             while (count != END)
             {
                 spiralstep();
                 count++;
                 if (arr[count] ==  1)
                     XDrawPoint(d, w, DefaultGC(d, s), y, x);
             }
         }    
         if (e.type == KeyPress)//Выходит при нажатии any key
             break;
         
    }
    return 0;
}